﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;
using System.Globalization;

namespace VidCoder.Converters;

public class InverseBoolConverter : IValueConverter
{
	public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
	{
		if (targetType != typeof(bool) && targetType != typeof(bool?))
		{
			throw new InvalidOperationException("The target must be a bool.");
		}

		return !(bool)value;
	}

	public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
	{
		if (targetType != typeof(bool))
		{
			throw new InvalidOperationException("The target must be a bool.");
		}

		return !(bool)value;
	}
}
